#ifndef _INTL_H
#define _INTL_H

#ifdef HAVE_CONFIG_H
#	include "config.h"
#endif

#ifdef ENABLE_NLS
#	include <libintl.h>
#	define _(String) gettext(String)
#	ifdef gettext_noop
#		define N_(String) gettext_noop(String)
#	else
#		define N_(String) (String)
#	endif
#else
#	define _(String) (String)
#	define N_(String) (String)
#	define bindtextdomain(Domain, Directory)
#	define bind_textdomain_codeset(Domain, Codeset)
#	define textdomain(Domain)
#endif

#endif /* _INTL_H */
