#ifndef _LEAFPAD_H
#define _LEAFPAD_H

/* autoconf */
#ifdef HAVE_CONFIG_H
#	include "config.h"
#endif

/* gettext */
#include "intl.h"

/* Shared Libraries */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>

/* Original Functions */
#include "dialog.h"
#include "file.h"
#include "search.h"
#include "font.h"
#include "encoding.h"
#include "utils.h"
#include "undo.h"
#include "indent.h"
#include "linenum.h"
#include "dnd.h"

/* Data Structure */
typedef struct {
	GtkWidget *window;
	GtkWidget *menubar;
	GtkWidget *textview;
	GtkTextBuffer *textbuffer;
} MainWindow;

typedef struct {
	MainWindow *mainwin;
	FileInfo *fi;
	gchar *filepath;
	/* config file */
	struct {
		gint width;
		gint height;
		gchar *fontname;
		gboolean wordwrap;
		gboolean linenumbers;
		gboolean autoindent;
		gchar *charset;
	} conf;
} StructData;

/* Local Functions */
#include "window.h"
#include "menu.h"
#include "callback.h"

#endif /* _LEAFPAD_H */
